/*
 * -- TYPES.C
 */

#include "types.h"

/* -- COURBE2NAPPE
 *
 * rempli la nappe avec les coordonnees des 2 courbes.
 * PS : max doit etre la taille des 3 entites.
 */
void courbe2nappe(Coords* courbe1, Coords* courbe2, Paire* nappe,
                  int max) {
  int i;

  for (i=0; i<max; i++) {
    nappe[i].a = courbe1[i];
    nappe[i].b = courbe2[i];
  }
}

/* -- NAPPE2COURBE
 *
 * rempli les 2 courbes avec les paires de coordonnees de la nappe.
 * PS : max doit etre la taille des 3 entites.
 */
void nappe2courbe(Paire* nappe, Coords* courbe1, Coords* courbe2,
                  int max) {
  int i;

  for (i=0; i<max; i++) {
    courbe1[i] = nappe[i].a;
    courbe2[i] = nappe[i].b;
  }
}
